<template>
  <main class="main py-5">
    <b-container>
      <b-row v-if="page">
        <b-col lg="10" class="mx-auto">
          <app-content :title="page.title" :image="page.image" :excerpt="page.excerpt" :description="page.body" />
        </b-col>
      </b-row>
    </b-container>
  </main>
</template>

<script>
import { mapGetters } from 'vuex'
import appContent from '~/components/PageContent.vue'
export default {
  name: 'AppPage',
  middleware ({ store, redirect, params }) {
    if (store.state.page.menu.length) {
      const page = store.state.page.menu.find(item => item.parameters.slug === params.slug)
      if (!page) {
        // redirect('/404')
      }
    }
  },
  components: {
    appContent
  },
  async fetch ({ store, params }) {
    await store.dispatch('page/FETCH_PAGE', {
      slug: params.slug
    })
  },
  computed: {
    ...mapGetters({
      page: 'page/getPage'
    })
  },
  head () {
    const title = this.page.title
    const description = this.page.meta.description
    const keywords = this.page.meta.keywords
    const image = this.$options.filters.image(this.page.cover)
    return {
      title,
      meta: [
        {
          hid: 'description',
          name: 'description',
          content: description
        },
        {
          hid: 'og:title',
          property: 'og:title',
          content: title
        },
        {
          hid: 'og:description',
          property: 'og:description',
          content: description
        },
        {
          hid: 'keywords',
          name: 'keywords',
          content: keywords
        },
        {
          hid: 'og:image',
          property: 'og:image',
          content: image
        },
        {
          hid: 'og:image:width',
          property: 'og:image:width',
          content: '1000'
        },
        {
          hid: 'og:image:height',
          property: 'og:image:height',
          content: null
        }
      ]
    }
  }
}
</script>
